//=============================================================================
// 쌠 (C) 2003 ATMEL Corporation
//
// ̧:		MemoryChunk.cpp
// ߲:		Microsoft Visual C++ 6.0
// o͗:
// 쐬:		4-Feb-2003	JP (ATMEL̨)
// ύX:
//
// xҰ:		avr@atmel.com
//
// :		MemoryChunkDataBuffer󂯌p܂BāA'addressM'
//				ނp؈ʒů֘A܂B
//
// ̑:
//=============================================================================

#include "MemoryChunk.h"

//=============================================================================
// {ݽ׸

MemoryChunk::MemoryChunk(unsigned char emptyFill) : addressM(0),
	emptyFillM(emptyFill), DataBuffer()
{
	// 
}

//=============================================================================
// DataBufferڽɊ֘Atݽ׸

MemoryChunk::MemoryChunk(int address, const DataBuffer& data,
	unsigned char emptyFill) : addressM(address), emptyFillM(emptyFill),
	DataBuffer(data)
{
	// 
}

//=============================================================================
// ݽ׸

MemoryChunk::MemoryChunk(const MemoryChunk& chunk) : DataBuffer(chunk),
	addressM(chunk.addressM)
{
	// 
}

//=============================================================================
// ޽׸

MemoryChunk::~MemoryChunk()
{
	// 
}

//=============================================================================
// MemoryChunk^rvalue蓖āBPrvalue̕ʂ܂B

MemoryChunk& MemoryChunk::operator =(const MemoryChunk& rvalue)
{
	if (this != &rvalue)
	{
		DataBuffer::operator = (rvalue);
		addressM = rvalue.addressM;
		emptyFillM = rvalue.emptyFillM;
	}

	return *this;
}

//=============================================================================
// ڽMemoryChunk̈Ȃΐ^Ԃ܂B

bool MemoryChunk::in(unsigned int address)
{
	return (address >= getStartAddress()) && (address <= getEndAddress());
}

//=============================================================================
// ڽMemoryChunkȂMemoryChunk޲Ă擾B
// MemoryChunk'missed'Ȃ'emptyFillM'Ԃ܂B

unsigned char MemoryChunk::operator [] (int address)
{
	return in(address) ?
		DataBuffer::operator [](address - addressM) : emptyFillM;
}

//=============================================================================
// ̊JnڽԂ܂B

unsigned int MemoryChunk::getStartAddress()
{
	return addressM;
}

//=============================================================================
// ̏IڽԂ܂B

unsigned int MemoryChunk::getEndAddress()
{
	return addressM + size() - 1;
}
