//=============================================================================
// 쌠 (C) 2003 ATMEL Corporation
//
// ̧:		MemoryChunk.h
// ߲:		Microsoft Visual C++ 6.0
// o͗:
// 쐬:		4-Feb-2003	JP (ATMEL̨)
// ύX:
//
// xҰ:		avr@atmel.com
//
// :		MemoryChunkDataBuffer󂯌p܂BāA'addressM'
//				ނp؈ʒů֘A܂B
//
// ̑:
//=============================================================================

#ifndef MEMORYCHUNK_H
#define MEMORYCHUNK_H

#include "DataBuffer.h"

class MemoryChunk : public DataBuffer
{
public:
	MemoryChunk(int address, const DataBuffer& data, unsigned char emptyFill);
	MemoryChunk(unsigned char emptyFill = 0x00);
	MemoryChunk(const MemoryChunk& chunk);
	virtual ~MemoryChunk();

	MemoryChunk& operator =(const MemoryChunk& rvalue);
	bool in(unsigned int address);
	unsigned char operator[] (int address);

	unsigned int getStartAddress();
	unsigned int getEndAddress();

private:
	unsigned int addressM;
	unsigned char emptyFillM;
};

#endif	// MEMORYCHUNK_H
