//=============================================================================
// 쌠 (C) 2003 ATMEL Corporation
//
// ̧:		Update.cpp
// ߲:		Microsoft Visual C++ 6.0
// o͗:
// Ǝ:	E, VU
// 쐬:		27-Feb-2003	JP (ATMEL̨)
// ύX:
//
// xҰ:		avr@atmel.com
//
// :		۸т͖ړIΏAVRɈÍ̧ق𑗂̂Ɏgp
//				BÍ̧ق'create'°قpč쐬܂B
//
// ̑:
//=============================================================================

#include "ComPort.h"
#include "update.h"
#include <stdio.h>

//=============================================================================

char *copyrightString =
	"update v1.0 - Copyright (C) 2003 Atmel Corporation\n\n";

//=============================================================================

const char *usageString =
	"usage: update <filename.ext> [-COMx]\n\n"
	"  filename.ext    File containing flash upgrade buffer.\n"
	"  -COMx           Communications port number\n\n";

//=============================================================================
// n܂܂!BCOM߰ĂvJAɏՕ̧قǂ݁ACOM߰ČoRŖ
// IΏ޲֊ɏՕ𑗂܂B

int main(int argc, char* argv[])
{
	FILE *inFile;

	char comPortName[5];			// ]ɎgpCOM߰Ė
	unsigned char receivedByte;		// COM߰ĂM1޲
	unsigned char retries = 0;		// ܂ł̎s
	int index;						// ްɏՕ̎wW
	int frameSize;					// ݂ڰѓ޲Đ
	int bufferSize = 0;				// ɏՕ̑޲Đ
	int bytesSent = 0;				// ܂łɑ޲Đ

	unsigned char buffer[0x40000];	// ްopްɏՕ

	printf(copyrightString);

	ComPort *comPort = new ComPort;	// COM߰ ޼ުĂ̲ݽݽ

	argc--;
	argv++;

	// SȂꍇɌүނo
	if ((argc != 2) || (argv[0][0] == '-'))
	{
		printf(usageString);
		return -1;
	}

	// COM߰Ĕԍǂݍ
	if(strstr(_strupr(argv[1]), "-COM"))
		strcpy(comPortName, &argv[1][1]);
	else
	{
		printf(usageString);
		return -1;
	}

	inFile = fopen(argv[0], "rb");
	if (inFile == NULL)
	{
		printf("Error: File '%s' not found.\n", argv[0]);
		comPort->close();
		return -1;
	}

	// COM߰ĂJ
	if (!comPort->open(comPortName, CBR_9600, 2000))
	{
		printf("Error: %s in use or does not exist.\n", comPortName);
		return -1;
	}
	printf("%s opened.\n", comPortName);

	// ɏՕّ̧Ŝǂݍ
	while(fscanf(inFile, "%2X", &buffer[bufferSize]) == 1)
		bufferSize++;

	for(index = 0; index < bufferSize; index += frameSize)
	{
		frameSize = ((buffer[index] << 8) | buffer[index + 1]) + 2;

		// ǂȎM޲Ă
		comPort->setTimeOut(1);
		while (comPort->read(&receivedByte, 1));
		comPort->setTimeOut(4000);

		// ڰёo
		printf("\r                        \rTransferring.. %d%% done.",
			100 * bytesSent / bufferSize);
		comPort->write(&buffer[index], frameSize);

		// 
		if (comPort->read(&receivedByte, 1))
		{
			switch (receivedByte)
			{
				case Error_OK:
					bytesSent += frameSize;
					retries = 0;
					break;

				default: // Error_CRC:
					if (++retries < 4)
						index -= frameSize;
					else
					{
						printf("\nCRC error. File damaged.\n");
						comPort->close();
						fclose(inFile);
						return -1;
					}
					break;
			}
		}
		else
		{
			printf("\nFailed: Target is not responding.\n");

			comPort->close();
			fclose(inFile);

			return -1;
		}
	}

	// SI
	printf("\rTransferring.. 100%% done.  \n");
	fclose(inFile);
	comPort->close();

	printf("Target updated successfully.\n");
	return 0;
}
